/////////////////////////////////////////////////////////////////////////////////
//
// BkMail.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: BkMail.cpp,v $
 * Revision 1.12  2000/11/07 15:57:17  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 */


#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4786)


/////////////////////////////////////////////////////////////////////////////////
//
#include "BkMail.h"


/////////////////////////////////////////////////////////////////////////////////
//
BkMultipartManager::BkMultipartManager()
{
    child = NULL;
    next = NULL;
}


BkMultipartManager::~BkMultipartManager()
{
    delete child;
    delete next;
}


BkMail* BkMultipartManager::getChild() const
{
    return child;
}


BkMail* BkMultipartManager::getNext() const
{
    return next;
}


BkMail* BkMultipartManager::setChild(BkMail* newChild)
{
    delete child;
    child = newChild;
    return child;
}


BkMail* BkMultipartManager::addChild(BkMail* newChild)
{
    BkMail* child = getChild();
    if (child == NULL) {
        return setChild(newChild);
    }
    while (child->getNext()) {
        child = child->getNext();
    }
    return child->setNext(newChild);
}


BkMail* BkMultipartManager::setNext(BkMail* newNext)
{
    delete next;
    next = newNext;
    return next;
}


BkMailList::iterator
BkMultipartManager::find(const BkMail* item, const string& forType, const string& forSubtype, unsigned int flag)
{
    resultSearch.clear();
    explore(item, forType, forSubtype, flag);
    return resultSearch.begin();
}


void
BkMultipartManager::explore(const BkMail* item, const string& forType, const string& forSubtype, unsigned int flag)
{
    if (item == NULL) {
        return;
    }

    if ((forType.empty() || stricmp(forType.c_str(), item->getType().c_str()) == 0) &&
         (forSubtype.empty() || stricmp(forSubtype.c_str(), item->getSubtype().c_str()) == 0)) {
        resultSearch.push_back(const_cast<BkMail*>(item));
    }

    if (flag & FINDMIMEITEM_FIRST_CHILD) {
        BkMail* nexttarget = item->getChild();
        if (nexttarget) {
            if (flag & FINDMIMEITEM_FIRST_ONE) {
                flag ^= FINDMIMEITEM_FIRST_CHILD;
            }
            explore(nexttarget, forType, forSubtype, flag);
        }
        if (flag & FINDMIMEITEM_NEXT) {
            nexttarget = item->getNext();
            if (nexttarget) {
                if (flag & FINDMIMEITEM_SECOND_ONE) {
                    flag ^= FINDMIMEITEM_NEXT;
                }
                explore(nexttarget, forType, forSubtype, flag);
            }
        }
    }
    else if (flag & FINDMIMEITEM_FIRST_NEXT) {
        BkMail* nexttarget = item->getNext();
        if (nexttarget) {
            if (flag & FINDMIMEITEM_FIRST_ONE) {
                flag ^= FINDMIMEITEM_FIRST_NEXT;
            }
            explore(nexttarget, forType, forSubtype, flag);
        }
        if (flag & FINDMIMEITEM_CHILD) {
            nexttarget = item->getNext();
            if (nexttarget) {
                if (flag & FINDMIMEITEM_SECOND_ONE) {
                    flag ^= FINDMIMEITEM_CHILD;
                }
                explore(nexttarget, forType, forSubtype, flag);
            }
        }
    }
}


/////////////////////////////////////////////////////////////////////////////////
//
/**
 * Destructer
 * ɉȂ
 */
BkMail::~BkMail()
{
}


/**
 * wb_̎擾
 * @param   name    in  擾wb_
 * @return  擾wb_
 */
string BkMail::getHeader(const string& name)
{
    StringList::iterator first = headers.begin();
    StringList::iterator last = headers.end();
    string result;

    while (first != last) {
        if (strnicmp((*first).c_str(), name.c_str(), name.size()) == 0) {
            string::iterator begin = (*first).begin();
            string::iterator end = (*first).end();
            advance(begin, name.size());
            if (begin != end && *begin == ':' && ++begin != end) {
                begin = find_if(begin, end, not_equal_to_lswp<string::value_type>());
                result.assign(begin, end);
                break;
            }
        }
        ++first;
    }
    return result;
}


/**
 * wb_̒ǉύX
 * @param   name    in  ǉEύXswb_
 * @param   data    in  ǉEύXswb_̃f[^B󕶎̂Ƃ̓wb_폜B
 */
void BkMail::setHeader(const string& name, const string& data)
{
    string header;
    header = name + ":\x20" + data;
    parseContentType(header);

    StringList::iterator first = headers.begin();
    StringList::iterator last = headers.end();
    while (first != last) {
        if (strnicmp((*first).c_str(), name.c_str(), name.size()) == 0) {
            string::iterator begin = (*first).begin();
            string::iterator end = (*first).end();
            advance(begin, name.size());
            if (begin != end && *begin == ':') {
                if (data.size()) {
                    *first = header;
                }
                else {
                    headers.erase(first);
                }
                return;
            }
        }
        ++first;
    }
    headers.push_back(header);
}


/**
 * MIME Type̔B
 */
bool BkMail::isMime(const string& toType, const string& toSubtype = "")
{
    return (getType().compare(toType) == 0 &&
            getSubtype().compare(toSubtype) == 0);
}


/**
 * [\[X
 * @param   newSource       Vi[郁[\[XB
 * @param   boundaryParent  BkMailCX^Xqp[gȂ΁Aep[g
 *                          boundaryݒ肷B
 */
void BkMail::fromString(const string& newSource, const string& boundaryParent)
{
    LineReader first(newSource);
    LineReader last;

    fromString(first, last, boundaryParent);
}


/**
 * [\[X
 * @param   first           in-out  ͊Jnʒuw肷A[\[Xi[LineReaderIuWFNgiteratorB
 * @param   last            in      LineReaderIuWFNg̏I[iteratorB
 * @param   boundaryParent  in      BkMailCX^Xqp[gȂ΁Aep[gboundaryݒ肷B
 */
void BkMail::fromString(LineReader& first, LineReader& last, const string& boundaryParent)
{
    // 
    parseHeaders(first, last);
    parseBody(first, last, boundaryParent);
}


/**
 * wb_̉
 * @param   first   in-out  ͊Jnʒuw肷B[\[Xi[LineReaderIuWFNgiteratorB
 * @param   last    in      LineReaderIuWFNg̏I[iterator
 */
void BkMail::parseHeaders(LineReader& first, LineReader& last)
{
    string linebuf;
    headers.clear();
    //linebuf.reserve(65540);

    while (first != last) {
        connectHeaderLine(first, last, linebuf);
        // sȂ΁Awb_̏IƌȂB
        if (linebuf.empty()) {
            break;
        }
        // headersXgɍsi[B
        headers.push_back(linebuf);
        // Content-Typewb_̉́B
        parseContentType(linebuf);
    }
}


/**
 * sɂ܂wb_̐ڑ
 * @param   first   in-out  ڑJnʒuw肷B[\[Xi[LineReaderIuWFNgiteratorB
 * @param   last    in      LineReaderIuWFNg̏I[iterator
 * @param   linebuf in-out  ڑwb_i[buffer
 */
void BkMail::connectHeaderLine(LineReader& first, LineReader& last, string& linebuf)
{
    linebuf = *first;
    // 2sڈȍ~AsXy[X܂̓^ułΑOs̑ƌȂAheadersXg
    // 1ubNƂĊi[B
    for (++first;
         first != last && (*first).size() && ((*first).at(0) == ' ' || (*first).at(0) == '\t');
         ++first) {
        // 1ubNɊi[邽߁AsR[h}ĂAsڑB
        linebuf += "\r\n";
        linebuf += *first;
    }
}


/*
 * Content-Typewb_́B܂AboundaryΎ擾B
 * @param   header  in  ͂wb_BContent-Typewb_łKv͂ȂB
 */
void BkMail::parseContentType(const string& header)
{
    if (strnicmp(header.c_str(), "Content-Type:", 13) == 0) {
        tokenizer token("/ \t", header.c_str() + 13);
        multipart.setType(*token);
        token.set_new_sep("; \r\n\t");
        multipart.setSubtype(*token);
        // p[^͂B
        string text = *token.set_new_sep("");
        string option;
        string value;
        string::iterator begin = text.begin();
        string::iterator end = text.end();
        while (getOption(begin, end, option, value)) {
            if (stricmp(option.c_str(), "boundary") == 0) {
                multipart.setBoundary(value);
            }
        }
    }
}


/**
 * Content-TypeIvV̉
 * @param   begin   in-out  ͂Jn[ʒuw肷B
 * @param   end     in      ͂镶̏I[ʒuw肷B
 * @param   option  out     擾option̊i[w肷B
 * @param   value   out     擾value̊i[w肷B
 */
bool BkMail::getOption(string::iterator& begin, string::iterator& end, string& option, string& value)
{
    // breakƂ"\t\x20;\r\n"gpĂB
    // option擾B
    string::iterator option_begin = find_if(begin, end, not_equal_to_break<string::value_type>());
    string::iterator option_end = find(option_begin, end, '=');
    if (option_end == end) {
        return false;
    }
    option.assign(option_begin, option_end);
    // value擾B
    string::iterator value_begin = find_if(++option_end, end, not_equal_to_break<string::value_type>());
    string::iterator value_end;
    if (value_begin == end) {
        return false;
    }
    if (*value_begin == '\"') { // : boundary="foo";
        value_end = find(++value_begin, end, '\"');
        value.assign(value_begin, value_end);
    }
    else { // : boundary=foo;
        value_end = find_if(value_begin, end, equal_to_break<string::value_type>());
        value.assign(value_begin, value_end);
    }
    // option̓oB
    begin = (value_end != end) ? find_if(++value_end, end, not_equal_to_break<string::value_type>()) : end;
    return true;
}


/**
 * Body
 * @param   first           ͊Jnʒuw肷A[\[Xi[LineReaderIuWFNgiteratorB
 * @param   last            LineReaderIuWFNg̏I[iteratorB
 * @param   boundaryParent  BkMailCX^Xqp[gȂ΁Aep[gboundaryݒ肷B
 */
void BkMail::parseBody(LineReader& first, LineReader& last, const string& boundaryParent)
{
    const string& boundary = getBoundary();
    string::size_type sizeBoundary = boundary.size();
    string::size_type sizeBoundaryParent = boundaryParent.size();

    bool isMultipart = (sizeBoundary) ? true : false;
    bool isChild = (sizeBoundaryParent) ? true : false;
    bool isBody = true;

    body.clear();
    trail.clear();

    while (first != last) {
        if ((*first).compare(0, 2, "--") == 0) { // maybe boudary?
            string::size_type sizeLine = (*first).size();
            if (isMultipart && (*first).compare(2, sizeBoundary, boundary) == 0) { // Is this boundary?
                if (sizeLine - 4 >= sizeBoundary && (*first).compare(2 + sizeBoundary, 2, "--") == 0) {
                    isMultipart = false;
                    isBody = false;
                    ++first;
                    continue;
                }
                else {
                    BkMail* newChild = createInstance();
                    newChild->fromString(++first, last, boundary);
                    addChild(newChild);
                    continue;
                }
            }
            else if (isChild && (*first).compare(2, sizeBoundaryParent, boundaryParent) == 0) {
                return;
            }
        }
        (isBody) ? body.push_back(*first) : trail.push_back(*first);
        ++first;
    }
}


/**
 * [f[^̏o
 * @return  string  [\[X
 */
string BkMail::toString() const
{
    string buffer;
    const string::size_type reserve_size = 65536;
    string::size_type need;
    buffer.reserve(reserve_size);

    StringList::const_iterator line_begin = headers.begin();
    StringList::const_iterator line_end  = headers.end();
    for (; line_begin != line_end; ++line_begin) {
        need = buffer.size() + (*line_begin).size() + 10;
        while (need > buffer.capacity()) {
            if (buffer.capacity() >= buffer.max_size()) {
                return buffer;
            }
            buffer.reserve(buffer.capacity() + need + reserve_size);
        }
        buffer += *line_begin;
        buffer += "\r\n";
    }
    line_begin = body.begin();
    line_end = body.end();
    for (;line_begin != line_end; ++line_begin) {
        need = buffer.size() + (*line_begin).size() + 10;
        while (need > buffer.capacity()) {
            if (buffer.capacity() >= buffer.max_size()) {
                return buffer;
            }
            buffer.reserve(buffer.capacity() + need + reserve_size);
        }
        buffer += "\r\n";
        buffer += *line_begin;
    }
    if (getChild()) {
        BkMail* child = getChild();
        const string& boundary = getBoundary();
        string::size_type boundarySize = boundary.size();
        do {
            string childSource = child->toString();
            need = buffer.size() + boundarySize + 10 + childSource.size() + 10;
            while (need > buffer.capacity()) {
                if (buffer.capacity() >= buffer.max_size()) {
                    return buffer;
                }
                buffer.reserve(buffer.capacity() + need + reserve_size);
            }
            buffer += "\r\n";
            buffer += "--";
            buffer += boundary;
            buffer += "\r\n";
            buffer += childSource;
            child = child->getNext();
        } while (child);
        need = buffer.size() + boundarySize + 10;
        while (need > buffer.capacity()) {
            if (buffer.capacity() >= buffer.max_size()) {
                return buffer;
            }
            buffer.reserve(buffer.capacity() + need + reserve_size);
        }
        line_begin = trail.begin();
        line_end = trail.end();
        buffer += "\r\n--";
        buffer += boundary;
        buffer += (line_begin != line_end) ? "--" : "--\r\n";
        for (; line_begin != line_end; ++line_begin) {
            need = buffer.size() + (*line_begin).size() + 10;
            while (need > buffer.capacity()) {
                if (buffer.capacity() >= buffer.max_size()) {
                    return buffer;
                }
                buffer.reserve(buffer.capacity() + need + reserve_size);
            }
            buffer += "\r\n";
            buffer += *line_begin;
        }
    }
    return buffer;
}


void BkMail::pushHeaderFront(const string& data)
{
    LineReader first(data);
    LineReader last;
    StringList::iterator iter = headers.begin();
    string linebuf;

    while (first != last) {
        connectHeaderLine(first, last, linebuf);
        // sȂ΁Awb_̏IƌȂB
        if (linebuf.empty()) {
            break;
        }
        // headersXgɍsi[B
        headers.insert(iter, linebuf);
        ++first;
    }
}


void BkMail::pushHeaderBack(const string& data)
{
    LineReader first(data);
    LineReader last;
    string linebuf;

    while (first != last) {
        connectHeaderLine(first, last, linebuf);
        // sȂ΁Awb_̏IƌȂB
        if (linebuf.empty()) {
            break;
        }
        // headersXgɍsi[B
        headers.push_back(linebuf);
        ++first;
    }
}


void BkMail::clearHeader()
{
    headers.clear();
}


void BkMail::pushBodyFront(const string& data)
{
    LineReader first(data);
    LineReader last;
    StringList::iterator iter = body.begin();

    while (first != last) {
        body.insert(iter, *first);
        ++first;
    }
}


void BkMail::pushBodyBack(const string& data)
{
    LineReader first(data);
    LineReader last;

    while (first != last) {
        body.push_back(*first);
        ++first;
    }
}


void BkMail::clearBody()
{
    body.clear();
}


void BkMail::pushTrailFront(const string& data)
{
    LineReader first(data);
    LineReader last;
    StringList::iterator iter = body.begin();

    while (first != last) {
        trail.insert(iter, *first);
        ++first;
    }
}


void BkMail::pushTrailBack(const string& data)
{
    LineReader first(data);
    LineReader last;
    StringList::iterator iter = body.begin();

    while (first != last) {
        trail.push_back(*first);
        ++first;
    }
}


void BkMail::clearTrail()
{
    trail.clear();
}


BkMail* BkMail::getRfc822()
{
    string source = toString();
    string::size_type pos = source.find_first_of("\r\n\r\n");
    if (pos == string::npos || pos+4 >= source.size()) {
        return NULL;
    }
    string rfc822source(source, pos+4);
    return new BkMail(rfc822source);
}


/////////////////////////////////////////////////////////////////////////////////
//
#pragma warning(pop) /* restore previous warning */
