/////////////////////////////////////////////////////////////////////////////////
//
// DecryptListener.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: DecryptListener.cpp,v $
 * Revision 1.4  2000/11/07 15:57:17  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 * Revision 1.3  2000/07/20 05:10:48  syou
 * - PGP/MIME[̏،ʕ\@Aꂽp[gƓKw
 *   multipartƂĂ݂Bmulipart`ŕ̔폐p[g[
 *   ɂāȀЂƂЂƂ̌،ʂ\邱ƂlAUTF-8
 *   ISO-8859-1Ƃ[p[g؂ĂȂ1ނ̃GR[fB
 *   OXL[Ō،ʂ\ł悤ɂ邽߁BA[{̂
 *   Subjectŉ炩̃GR[hsĂƁAep[gContent-Typew
 *   QƂȂȂ錻ۂB2ibeta22jŌ󂯂Bǂ̂낤B
 *   Iɂ́Aɏ揼BkCommon.hABkCommon.cppɎĂ܂
 *   B揼񂪗t@C̃o[WAbvvĂȒPɒǏ]ł
 *   ͂Ȃ̂ǂACMIMEItemɗ~֐
 *   ł̂ƁAƂGetNameAndAddr()CMIMEItem::~CMIMEItem()̃
 *   [NACMIMEItemɑ΂ACMIMEItem::SetHeader()găwb_ݒ肵
 *   ĂƂɃANZXᔽN邱Ƃւ̑ΏȂǂs߁B
 *   񂩂A_CrtSetDbgFlag()giC}KW8Ƃ̂͂܂
 *   RƂĂj[NΏɂƂ߂B݂̂ƂAĂ
 *   Ń胊[N͑Ώς݁B
 *   APGPsdkUILibInit()ɂPGP UICȕDllMain()JɏW
 *   ȂǁB
 *
 * Revision 1.2  2000/07/15 02:09:55  syou
 * - PGP/MIMEÍƏꂽ[̏؂Bclass
 *   CDecryptListenerclass CSignatureListenerhAPGP/MIME
 *   ꂽ[̏؂ƁA\[`LBƂ
 *   CɂȂ̂͂2̃NX̖OAPGPEventtׂH
 *
 * Revision 1.1  2000/07/13 15:12:24  syou
 * - PGP/MIME`̈Í[̕B
 *   PGPEventHandlerAeListenerƂɎ悤ɂBclass CEventListener
 *   hIuWFNgEventHandlerꂼĎgB
 *   SignatureData.h폜AEventListener.hAEventListener.cppASignatureListener.h
 *   SignatureListener.cppADecryptListener.hADecryptListener.cppǉB
 *   count_ptr<CBkMailPart*>CBkMailPartPtrtypedefB
 *   \[XSʂɓnāAfree(memoryblock*)̑OmemoryblockNULLłȂ
 *   `FbNĂ̂AMSDNCu[̃QW[t@XQƂɍ폜B
 *
 */


#include <windows.h>
#include "DecryptListener.h"


/////////////////////////////////////////////////////////////////////////////////
//
DecryptListener::DecryptListener()
{
    SignatureListener::SignatureListener();
    hWnd = NULL;
}


DecryptListener::~DecryptListener()
{
}


void DecryptListener::setWindowHandle(HWND newHWnd)
{
    hWnd = newHWnd;
}


HWND DecryptListener::getWindowHandle() const
{
    return hWnd;
}


PGPError DecryptListener::inputPassphrase(PGPContextRef context, PGPEvent* event)
{
    PGPEventPassphraseData *d = &event->data.passphraseData;
    LPSTR lpPassphrase = NULL;
    PGPError err = kPGPError_NoErr;
    if (d->fConventional) {
        err = PGPConventionalDecryptionPassphraseDialog(
                context,
                PGPOUIOutputPassphrase(context, &lpPassphrase),
                PGPOUIParentWindowHandle(context, getWindowHandle()),
                PGPOUIVerifyPassphrase(context, TRUE),
                PGPOLastOption(context)
                );
    }
    else {
        PGPKeyID keyIDList[1];
        PGPKeyRef decryptionKey;
        err = PGPDecryptionPassphraseDialog(
                context,
                d->keyset,
                0,
                keyIDList,
                &decryptionKey,
                PGPOUIOutputPassphrase(context, &lpPassphrase),
                PGPOUIParentWindowHandle(context, getWindowHandle()),
                PGPOUIVerifyPassphrase(context, TRUE),
                PGPOLastOption(context)
                );
    }

    if (IsPGPError(err)) {
        return kPGPError_UserAbort;
    }

    err = PGPAddJobOptions(event->job,
        PGPOPassphraseBuffer(context, lpPassphrase, strlen(lpPassphrase)),
        PGPOLastOption(context)
        );

    PGPFreeData(lpPassphrase);

    if (IsPGPError(err)) {
        return kPGPError_UserAbort;
    }

    return kPGPError_NoErr;
}


PGPError DecryptListener::listenEvent(PGPContextRef context, PGPEvent* event)
{
    PGPError err = kPGPError_NoErr;
    switch(event->type)
    {
    case kPGPEvent_PassphraseEvent:
        err = inputPassphrase(context, event);
        break;
    default:
        err = SignatureListener::listenEvent(context, event);
        break;
    }

    return err;
}
