/////////////////////////////////////////////////////////////////////////////////
//
// SignatureListener.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: SignatureListener.cpp,v $
 * Revision 1.3  2000/11/07 15:57:20  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 * Revision 1.2  2000/07/15 02:09:56  syou
 * - PGP/MIMEÍƏꂽ[̏؂Bclass
 *   CDecryptListenerclass CSignatureListenerhAPGP/MIME
 *   ꂽ[̏؂ƁA\[`LBƂ
 *   CɂȂ̂͂2̃NX̖OAPGPEventtׂH
 *
 * Revision 1.1  2000/07/13 15:12:24  syou
 * - PGP/MIME`̈Í[̕B
 *   PGPEventHandlerAeListenerƂɎ悤ɂBclass CEventListener
 *   hIuWFNgEventHandlerꂼĎgB
 *   SignatureData.h폜AEventListener.hAEventListener.cppASignatureListener.h
 *   SignatureListener.cppADecryptListener.hADecryptListener.cppǉB
 *   count_ptr<CBkMailPart*>CBkMailPartPtrtypedefB
 *   \[XSʂɓnāAfree(memoryblock*)̑OmemoryblockNULLłȂ
 *   `FbNĂ̂AMSDNCu[̃QW[t@XQƂɍ폜B
 *
 */


#include <windows.h>
#include "SignatureListener.h"


/////////////////////////////////////////////////////////////////////////////////
//
SignatureListener::SignatureListener()
{
    name = NULL;
    didSigning = false;
    ::ZeroMemory(&sigData.signingKeyID, sizeof(sigData.signingKeyID));
    sigData.signingKey = kInvalidPGPKeyRef;
    sigData.checked = FALSE;
    sigData.verified = FALSE;
    sigData.keyRevoked = FALSE;
    sigData.keyDisabled = FALSE;
    sigData.keyExpired = FALSE;
    sigData.keyMeetsValidityThreshold = FALSE;
    sigData.keyValidity = kPGPValidity_Unknown;
    sigData.creationTime = kPGPExpirationTime_Never;
}


SignatureListener::~SignatureListener()
{
    delete [] name;
    name = NULL;
}


const PGPEventSignatureData SignatureListener::getData() const
{
    return sigData;
}


const char* SignatureListener::getName() const
{
    return name;
}


const PGPValidity SignatureListener::getKeyValidity() const
{
    return sigData.keyValidity;
}


bool SignatureListener::isChecked() const
{
    return (sigData.checked == TRUE);
}


bool SignatureListener::isVerified() const
{
    return (sigData.verified == TRUE);
}


bool SignatureListener::isSigned() const
{
    return didSigning;
}


void SignatureListener::setSignatureEventData(PGPEvent* event)
{
    PGPEventSignatureData* data = reinterpret_cast<PGPEventSignatureData*>(&event->data.signatureData);
    sigData.signingKeyID = data->signingKeyID;
    sigData.signingKey = kInvalidPGPKeyRef;
    sigData.checked = data->checked;
    sigData.verified = data->verified;
    sigData.keyRevoked = data->keyRevoked;
    sigData.keyDisabled = data->keyDisabled;
    sigData.keyExpired = data->keyExpired;
    sigData.keyMeetsValidityThreshold = data->keyMeetsValidityThreshold;
    sigData.keyValidity = data->keyValidity;
    sigData.creationTime = data->creationTime;

    if (data->signingKey != kInvalidPGPKeyRef) {
        delete [] name;
        name = NULL;
        PGPSize namelen = 0;
        PGPGetPrimaryUserIDNameBuffer(data->signingKey, namelen, name, &namelen);
        name = new char[namelen+1];
        PGPGetPrimaryUserIDNameBuffer(data->signingKey, namelen, name, &namelen);
    }
}


PGPError SignatureListener::listenEvent(PGPContextRef context, PGPEvent* event)
{
    /* branch on the received event code */
    PGPError err = kPGPError_NoErr;
    switch(event->type)
    {
    case kPGPEvent_SignatureEvent:
        didSigning = true;
        setSignatureEventData(event);
        break;
    default:
        break;
    }

    return err;
}
