/////////////////////////////////////////////////////////////////////////////////
//
// tokenizer.h
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: tokenizer.h,v $
 * Revision 1.1  2000/11/07 15:57:20  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 */


#pragma once
#pragma warning(push)
#pragma warning(disable:4101)
#pragma warning(disable:4786)


/////////////////////////////////////////////////////////////////////////////////
//
#include <algorithm>
#include <string>


/////////////////////////////////////////////////////////////////////////////////
//
using namespace std;


/////////////////////////////////////////////////////////////////////////////////
//
#define SEPARATER_SPACE " "


/////////////////////////////////////////////////////////////////////////////////
//
class tokenizer : public iterator<input_iterator_tag, string>
{
    string src_;    // ΏۂƂȂ镶
    string sep_;    // ؂蕶̏W
    string tok_;    // ؂oꂽ

    string::size_type first_;
    string::size_type last_;
    void get_value();
    void get_value(const string& new_sep_);
public:
    tokenizer() : first_(string::npos), last_(string::npos) {}
    explicit tokenizer(const string& sep) : sep_(sep) {}
    explicit tokenizer(const char* sep) : sep_(sep) {}
    tokenizer(const string& sep, const string& src) : sep_(sep), src_(src)
    {   last_ = 0;  get_value();    }
    tokenizer(const char* sep, const char* src) : sep_(sep), src_(src)
    {   last_ = 0;  get_value();    }
    tokenizer(const tokenizer& t)
        : src_(t.src_), sep_(t.sep_), tok_(t.tok_), first_(t.first_), last_(t.last_)
    {}
    virtual ~tokenizer() {};

    tokenizer& operator=(const tokenizer& t) {
        src_ = t.src_;  sep_ = t.sep_;  tok_ = t.tok_;
        first_ = t.first_;  last_ = t.last_;
        return *this;
    }

    // Ώەݒ
    tokenizer& operator=(const string& src)
    {   src_ = src; last_ = 0;  get_value();    return *this;   }
    tokenizer& operator=(const char* src)
    {   src_ = src; last_ = 0;  get_value();    return *this;   }

    // vfij̎Q
    const string& operator*() const
    {   return tok_;    }
    const string* operator->() const
    {   return &tok_;   }

    // ̗vfij
    tokenizer& operator++()
    {   get_value();    return *this;   }
    tokenizer operator++(int)
    {   tokenizer tmp = *this;  get_value();    return tmp; }

    // rZ
    friend bool operator==(const tokenizer& x, const tokenizer& y)
    {   return x.first_ == y.first_ && x.last_ == y.last_;  }
    friend bool operator!=(const tokenizer& x, const tokenizer& y)
    {   return !(x == y);   }

    tokenizer& set_new_sep(const string& new_sep_)
    {   get_value(new_sep_); return *this; }
};


inline
void tokenizer::get_value()
{
    if (last_ == string::npos) { first_ = string::npos; return; }
    first_ = src_.find_first_not_of(sep_, last_);
    if (first_ == string::npos) { tok_ = ""; last_ = string::npos; return; }
    last_ = src_.find_first_of(sep_, first_);
    string::size_type n = (last_ == string::npos) ? last_ : last_-first_;
    tok_ = src_.substr(first_, n);
}


inline
void tokenizer::get_value(const string& new_sep_)
{
    if (last_ == string::npos) { sep_ = new_sep_; first_ = string::npos; return; }
    first_ = src_.find_first_not_of(sep_, last_);
    if (first_ == string::npos) { tok_ = ""; last_ = string::npos; return; }
    sep_ = new_sep_;
    last_ = src_.find_first_of(sep_, first_);
    string::size_type n = (last_ == string::npos) ? last_ : last_-first_;
    tok_ = src_.substr(first_, n);
}


/////////////////////////////////////////////////////////////////////////////////
//
#pragma warning(pop) /* restore previous warning */
